package com.com2us.module;

import org.json.JSONObject;

import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.util.Iterator;
import java.util.Map;
import android.util.Log;
import java.util.UUID;

public class HIVEAnalyticsLogPlugin {

    public static void AdLog(String eventType, String adUnitId, String uniqueSessionKey, String adNetwork, String adPlacementInfo, String rewardType, double rewardAmount) {

        JSONObject data = new JSONObject();
        try {
            data.put("category","hive_ad_watch_log");
            data.put("eventType", eventType);
            data.put("adUnitId", adUnitId);
            data.put("adNetwork", adNetwork);
            data.put("uniqueSessionKey", uniqueSessionKey);

            // if( eventType.equals("load") || eventType.equals("open") ) {
                data.put("adPlacement", adPlacementInfo);
            // }

            if( eventType.equals("reward") ) {
                data.put("rewardType", null);
                data.put("rewardAmount", null);
            }
            data.put("adSource", "ADOP");//ADOP Fixed
            
        } catch(Exception e) {
            e.printStackTrace();
        }

        sendAnalyticsLog(data);
    }

    public static String CreateUniqueSessionKey() {
        return UUID.randomUUID().toString().replace("-", "");
    }

    /**
     * 광고 시청 로그를 전송
     * API https://jira.gamevilcom2us.com/wiki/pages/viewpage.action?pageId=196621672
     * @param eventType 이벤트 타입 (load, open, reward, closed)
     * @param addtionalJsonObject 추가 전송 데이터
     */
    private static void sendAnalyticsLog(JSONObject data){
        try {
            /// HIVE SDK v4 - KS Plugin Target
            Class analyticsClass = null;
            try {
                analyticsClass = Class.forName("com.hive.v1.Analytics");
            } catch (ClassNotFoundException e) {
                analyticsClass = Class.forName("com.hive.Analytics");
            }
            Method sendLogMethod = analyticsClass.getMethod("sendAnalyticsLog", JSONObject.class);

            Object obj = null;
            try {
                /// Kotlin INSTANCE
                Field field = analyticsClass.getField("INSTANCE");
                if( field != null )
                    obj = field.get(null);
            } catch (Throwable ignore) {

            }
            sendLogMethod.invoke(obj, data);

        } catch (Throwable e) {
            e.printStackTrace();
        }
    }
}