//
//  AdMobTest.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by nanomech on 18/05/2020.
//

#ifndef AdMobTest_hpp
#define AdMobTest_hpp

#include <stdio.h>
// HIVE SDK v4 UI-Helper
#include "BaseView.hpp"
#include "HIVEAdKit.hpp"

class AdKitTest : public BaseView, HIVEAdKit::EventHandlers
{
public:
    CREATE_FUNC(AdKitTest);

    virtual bool init()override;
    virtual void onButtonEvent(int buttonTag)override;
    

private:
    enum : int {
        BUTTON_GDPR_RESET,
        BUTTON_GDPR_INIT0,
        BUTTON_GDPR_INIT1,
        BUTTON_GDPR_INIT2,
        BUTTON_GDPR_INIT3,
        BUTTON_INIT_ADKIT,
        BUTTON_INIT_REWARDED_VIDEO,
        BUTTON_LOAD_REWARDED_VIDEO,
        BUTTON_SHOW_REWARDED_VIDEO,
        BUTTON_INIT_INTERSTITIAL_AD,
        BUTTON_LOAD_INTERSTITIAL_AD,
        BUTTON_SHOW_INTERSTITIAL_AD,
        BUTTON_INIT_ADAPTIVE_BANNER,
        BUTTON_LOAD_ADAPTIVE_BANNER,
        BUTTON_SHOW_ADAPTIVE_BANNER,
        BUTTON_HIDE_ADAPTIVE_BANNER,
    };
public:
    
    HIVEAdKit::RewardVideo* rewardVideo;
    HIVEAdKit::Interstitial* interstitial;
    HIVEAdKit::AdaptiveBanner* adaptiveBanner;
    
    virtual void onAdLoaded(const char* zoneId) override;
    virtual void onAdOpening(const char* zoneId) override;
    virtual void onAdClosed(const char* zoneId) override;
    virtual void onAdReward(const char* zoneId) override;
    virtual void onAdClick(const char* zoneId) override;
    virtual void onAdSkip(const char* zoneId) override;
    virtual void onAdFail(const char* zoneId) override;

};

#endif /* AdMobTest_hpp */
