LOCAL_PATH := $(call my-dir)

include $(CLEAR_VARS)

LOCAL_MODULE := cc_static
LOCAL_MODULE_FILENAME := libcc

#en The header file search path is added on the recommended path in the official website document and 'cocos2d-x-3.17/cocos/Android.mk'
#zh 头文件搜索路径在官网文档静态库中推荐路径以及 cocos2d-x-3.17/cocos/Android.mk 的基础上添加

#link http://docs.cocos.com/cocos2d-x/manual/zh/editors_and_tools/prebuilt_libraries.html
# Project level
#/path_to_cocos2d-x/cocos2d-x/
#/path_to_cocos2d-x/cocos2d-x/cocos
#/path_to_cocos2d-x/cocos2d-x/cocos/base
#/path_to_cocos2d-x/cocos2d-x/cocos/physics
#/path_to_cocos2d-x/cocos2d-x/cocos/math
#/path_to_cocos2d-x/cocos2d-x/cocos/2d
#/path_to_cocos2d-x/cocos2d-x/cocos/ui
#/path_to_cocos2d-x/cocos2d-x/cocos/network
#/path_to_cocos2d-x/cocos2d-x/cocos/audio/include
#/path_to_cocos2d-x/cocos2d-x/cocos/editor-support
#/path_to_cocos2d-x/cocos2d-x/extensions
#/path_to_cocos2d-x/cocos2d-x/external
#/path_to_cocos2d-x/cocos2d-x/external/chipmunk/include/chipmunk

#en Add the environment variable COCOS_ROOT to the root of cocos2d-x, for example: D:\Cocos\cocos2d-x-3.17
#zh 添加环境变量 COCOS_ROOT，值为 cocos2d-x 的根目录，如：D:\Cocos\cocos2d-x-3.17
LOCAL_EXPORT_C_INCLUDES := $(COCOS_ROOT)/cocos                               \
                           $(COCOS_ROOT)/cocos/.                             \
                           $(COCOS_ROOT)/cocos/..                            \
                           $(COCOS_ROOT)/cocos/2d                            \
                           $(COCOS_ROOT)/cocos/audio/include                 \
                           $(COCOS_ROOT)/cocos/base                          \
                           $(COCOS_ROOT)/cocos/editor-support                \
                           $(COCOS_ROOT)/cocos/math                          \
                           $(COCOS_ROOT)/cocos/physics                       \
                           $(COCOS_ROOT)/cocos/platform                      \
                           $(COCOS_ROOT)/cocos/platform/android              \
                           $(COCOS_ROOT)/cocos/ui                            \
                           $(COCOS_ROOT)/external                            \
                           $(COCOS_ROOT)/external/Box2D                      \
                           $(COCOS_ROOT)/external/bullet/include/bullet      \
                           $(COCOS_ROOT)/external/chipmunk/include/chipmunk  \
                           $(COCOS_ROOT)/external/clipper                    \
                           $(COCOS_ROOT)/external/curl/include/android       \
                           $(COCOS_ROOT)/external/flatbuffers                \
                           $(COCOS_ROOT)/external/freetype2                  \
                           $(COCOS_ROOT)/external/poly2tri                   \
                           $(COCOS_ROOT)/external/poly2tri/common            \
                           $(COCOS_ROOT)/external/poly2tri/sweep             \
                           $(COCOS_ROOT)/external/tinyxml2                   \
                           $(COCOS_ROOT)/external/unzip                      \
                           $(COCOS_ROOT)/external/websockets/include/android \
                           $(COCOS_ROOT)/external/xxhash                     \
                           $(COCOS_ROOT)/external/xxtea                      \
                           $(COCOS_ROOT)/extensions


LOCAL_CFLAGS   :=  -DUSE_FILE32API -fexceptions

LOCAL_CPPFLAGS := -Wno-deprecated-declarations -Wno-extern-c-compat

LOCAL_EXPORT_CFLAGS   := -DUSE_FILE32API -fexceptions

LOCAL_EXPORT_CPPFLAGS := -Wno-deprecated-declarations -Wno-extern-c-compat

LOCAL_EXPORT_LDLIBS := -lGLESv2    \
                       -llog       \
                       -landroid   \
                       -lGLESv1_CM \
                       -lEGL       \
                       -lOpenSLES

#en Add library module name
#zh 添加库模块名
#LOCAL_STATIC_LIBRARIES := cocos_freetype2_static
#LOCAL_STATIC_LIBRARIES += cocos_png_static
#LOCAL_STATIC_LIBRARIES += cocos_jpeg_static
#LOCAL_STATIC_LIBRARIES += cocos_tiff_static
#LOCAL_STATIC_LIBRARIES += cocos_webp_static
#LOCAL_STATIC_LIBRARIES += cocos_chipmunk_static
#LOCAL_STATIC_LIBRARIES += cocos_zlib_static
#LOCAL_STATIC_LIBRARIES += cocos_ssl_static
#LOCAL_STATIC_LIBRARIES += recast_static
#LOCAL_STATIC_LIBRARIES += bullet_static

#LOCAL_WHOLE_STATIC_LIBRARIES := cocos2dxandroid_static
#LOCAL_WHOLE_STATIC_LIBRARIES += cpufeatures

#en Add external compiled libraries. The full library loading mode is used here, which will greatly increase the library size. 
#en You can use load mode instead, but you need to change the library order, otherwise the compilation will go wrong.
#zh 添加 external 目录已经编译好的库。这里使用的是全库加载模式，会大大增加库大小。可以改用使用加载模式，但需要修改库顺序，否则编译将出错。
LOCAL_WHOLE_STATIC_LIBRARIES := box2d_static
LOCAL_WHOLE_STATIC_LIBRARIES += bullet_static
LOCAL_WHOLE_STATIC_LIBRARIES += cocos_chipmunk_static
LOCAL_WHOLE_STATIC_LIBRARIES += cocos_curl_static
LOCAL_WHOLE_STATIC_LIBRARIES += cocos_freetype2_static
LOCAL_WHOLE_STATIC_LIBRARIES += cocos_jpeg_static
LOCAL_WHOLE_STATIC_LIBRARIES += cocos_crypto_static
LOCAL_WHOLE_STATIC_LIBRARIES += cocos_ssl_static
LOCAL_WHOLE_STATIC_LIBRARIES += cocos_png_static
LOCAL_WHOLE_STATIC_LIBRARIES += cocos_tiff_static
LOCAL_WHOLE_STATIC_LIBRARIES += cocos_webp_static
LOCAL_WHOLE_STATIC_LIBRARIES += websockets_static
LOCAL_WHOLE_STATIC_LIBRARIES += cocos_zlib_static

#en Add a static library generated by 'cocos gen-libs -p android'.
#zh 添加通过 cocos gen-libs -p android 产生的静态库。
# LOCAL_WHOLE_STATIC_LIBRARIES += cocos_flatbuffers_static
LOCAL_WHOLE_STATIC_LIBRARIES += audioengine_static
LOCAL_WHOLE_STATIC_LIBRARIES += cocos2dx_static
LOCAL_WHOLE_STATIC_LIBRARIES += cocos2dxandroid_static
LOCAL_WHOLE_STATIC_LIBRARIES += cocos2dx_internal_static
LOCAL_WHOLE_STATIC_LIBRARIES += cocos3d_static
LOCAL_WHOLE_STATIC_LIBRARIES += cocosbuilder_static
LOCAL_WHOLE_STATIC_LIBRARIES += cocosdenshion_static
LOCAL_WHOLE_STATIC_LIBRARIES += cocostudio_static
LOCAL_WHOLE_STATIC_LIBRARIES += cpufeatures
LOCAL_WHOLE_STATIC_LIBRARIES += cocos_extension_static
LOCAL_WHOLE_STATIC_LIBRARIES += cocos_network_static
LOCAL_WHOLE_STATIC_LIBRARIES += libpvmp3dec
LOCAL_WHOLE_STATIC_LIBRARIES += recast_static
LOCAL_WHOLE_STATIC_LIBRARIES += spine_static
LOCAL_WHOLE_STATIC_LIBRARIES += cocos_ui_static
LOCAL_WHOLE_STATIC_LIBRARIES += libvorbisidec

include $(BUILD_STATIC_LIBRARY)

#en Add module definition for the external static libraries. Get it by copying content from each library's Android.mk and adjusting the path.
#zh 为 external 目录的静态库添加模块定义。通过从各个库的 Android.mk 中复制内容，然后调整路径得到。
#=================================================================================
include $(CLEAR_VARS)
LOCAL_MODULE    := websockets_static
LOCAL_MODULE_FILENAME := libwebsockets_static
LOCAL_SRC_FILES := $(COCOS_ROOT)/external/websockets/prebuilt/android/$(TARGET_ARCH_ABI)/libwebsockets.a
LOCAL_EXPORT_C_INCLUDES := $(COCOS_ROOT)/external/websockets/include/android
LOCAL_CPPFLAGS := -D__STDC_LIMIT_MACROS=1
LOCAL_EXPORT_CPPFLAGS := -D__STDC_LIMIT_MACROS=1

LOCAL_STATIC_LIBRARIES += cocos_ssl_static
LOCAL_STATIC_LIBRARIES += cocos_crypto_static

include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
include $(CLEAR_VARS)
LOCAL_MODULE := cocos_webp_static
LOCAL_MODULE_FILENAME := webp
LOCAL_SRC_FILES := $(COCOS_ROOT)/external/webp/prebuilt/android/$(TARGET_ARCH_ABI)/libwebp.a
LOCAL_EXPORT_C_INCLUDES := $(COCOS_ROOT)/external/webp/include/android

#LOCAL_WHOLE_STATIC_LIBRARIES := cpufeatures

ifeq ($(TARGET_ARCH_ABI),armeabi-v7a)
    LOCAL_CFLAGS := -DHAVE_NEON=1
endif

include $(PREBUILT_STATIC_LIBRARY)

#$(call import-module, android/cpufeatures)

#=================================================================================
include $(CLEAR_VARS)
LOCAL_MODULE := cocos_tiff_static
LOCAL_MODULE_FILENAME := tiff
LOCAL_SRC_FILES := $(COCOS_ROOT)/external/tiff/prebuilt/android/$(TARGET_ARCH_ABI)/libtiff.a
LOCAL_EXPORT_C_INCLUDES := $(COCOS_ROOT)/external/tiff/include/android
include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
#include $(CLEAR_VARS)
#LOCAL_MODULE := spidermonkey_static
#LOCAL_MODULE_FILENAME := js_static
#LOCAL_SRC_FILES := $(TARGET_ARCH_ABI)/libjs_static.a
#LOCAL_EXPORT_C_INCLUDES := $(COCOS_ROOT)/external/spidermonkey/include/android
#LOCAL_CPPFLAGS := -D__STDC_LIMIT_MACROS=1 -Wno-invalid-offsetof
#LOCAL_EXPORT_CPPFLAGS := -D__STDC_LIMIT_MACROS=1 -Wno-invalid-offsetof
#include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
include $(CLEAR_VARS)
LOCAL_MODULE := cocos_png_static
LOCAL_MODULE_FILENAME := png
LOCAL_SRC_FILES := $(COCOS_ROOT)/external/png/prebuilt/android/$(TARGET_ARCH_ABI)/libpng.a
LOCAL_EXPORT_C_INCLUDES := $(COCOS_ROOT)/external/png/include/android
include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
include $(CLEAR_VARS)

LOCAL_MODULE := cocos_crypto_static
LOCAL_MODULE_FILENAME := crypto
LOCAL_SRC_FILES := $(COCOS_ROOT)/external/openssl/prebuilt/android/$(TARGET_ARCH_ABI)/libcrypto.a
LOCAL_EXPORT_C_INCLUDES := $(COCOS_ROOT)/external/openssl/include/android
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := cocos_ssl_static
LOCAL_MODULE_FILENAME := ssl
LOCAL_SRC_FILES := $(COCOS_ROOT)/external/openssl/prebuilt/android/$(TARGET_ARCH_ABI)/libssl.a
LOCAL_EXPORT_C_INCLUDES := $(COCOS_ROOT)/external/openssl/include/android
include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
#include $(CLEAR_VARS)
#LOCAL_MODULE    := luajit_static
#LOCAL_MODULE_FILENAME := libluajit
#LOCAL_SRC_FILES := $(TARGET_ARCH_ABI)/libluajit.a
#LOCAL_EXPORT_C_INCLUDES := $(COCOS_ROOT)/external/lua/luajit/include
#include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
include $(CLEAR_VARS)
LOCAL_MODULE := cocos_jpeg_static
LOCAL_MODULE_FILENAME := jpeg
LOCAL_SRC_FILES := $(COCOS_ROOT)/external/jpeg/prebuilt/android/$(TARGET_ARCH_ABI)/libjpeg.a
LOCAL_EXPORT_C_INCLUDES := $(COCOS_ROOT)/external/jpeg/include/android
include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
include $(CLEAR_VARS)
LOCAL_MODULE := cocos_freetype2_static
LOCAL_MODULE_FILENAME := freetype2
LOCAL_SRC_FILES := $(COCOS_ROOT)/external/freetype2/prebuilt/android/$(TARGET_ARCH_ABI)/libfreetype.a
LOCAL_EXPORT_C_INCLUDES := $(COCOS_ROOT)/external/freetype2/include/android           \
                           $(COCOS_ROOT)/external/freetype2/include/android/freetype2
include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
include $(CLEAR_VARS)
LOCAL_MODULE := cocos_curl_static
LOCAL_MODULE_FILENAME := curl
LOCAL_SRC_FILES := $(COCOS_ROOT)/external/curl/prebuilt/android/$(TARGET_ARCH_ABI)/libcurl.a
LOCAL_EXPORT_C_INCLUDES := $(COCOS_ROOT)/external/curl/include/android
#LOCAL_STATIC_LIBRARIES += cocos_ssl_static
#LOCAL_STATIC_LIBRARIES += cocos_crypto_static
include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
include $(CLEAR_VARS)
LOCAL_MODULE := cocos_chipmunk_static
LOCAL_MODULE_FILENAME := chipmunk
LOCAL_SRC_FILES := $(COCOS_ROOT)/external/chipmunk/prebuilt/android/$(TARGET_ARCH_ABI)/libchipmunk.a
LOCAL_EXPORT_C_INCLUDES := $(COCOS_ROOT)/external/chipmunk/include
include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
include $(CLEAR_VARS)
LOCAL_MODULE    := bullet_static
LOCAL_MODULE_FILENAME := bullet_static
LOCAL_SRC_FILES := $(COCOS_ROOT)/external/bullet/prebuilt/android/$(TARGET_ARCH_ABI)/libLinearMath.a
LOCAL_EXPORT_C_INCLUDES := $(COCOS_ROOT)/external/bullet/include
LOCAL_EXPORT_C_INCLUDES += $(COCOS_ROOT)/external/bullet/include/bullet
LOCAL_STATIC_LIBRARIES += cocos_bulletcollision_static
LOCAL_STATIC_LIBRARIES += cocos_bulletdynamics_static
LOCAL_STATIC_LIBRARIES += cocos_bulletmultithreaded_static
# LOCAL_STATIC_LIBRARIES += cocos_linearmath_static
LOCAL_STATIC_LIBRARIES += cocos_minicl_static
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := cocos_bulletcollision_static
LOCAL_MODULE_FILENAME := bulletcollision
LOCAL_SRC_FILES := $(COCOS_ROOT)/external/bullet/prebuilt/android/$(TARGET_ARCH_ABI)/libBulletCollision.a
LOCAL_EXPORT_C_INCLUDES := $(COCOS_ROOT)/external/bullet/include
LOCAL_STATIC_LIBRARIES += cocos_linearmath_static
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := cocos_bulletdynamics_static
LOCAL_MODULE_FILENAME := bulletdynamics
LOCAL_SRC_FILES := $(COCOS_ROOT)/external/bullet/prebuilt/android/$(TARGET_ARCH_ABI)/libBulletDynamics.a
LOCAL_EXPORT_C_INCLUDES := $(COCOS_ROOT)/external/bullet/include
LOCAL_STATIC_LIBRARIES += cocos_bulletcollision_static
LOCAL_STATIC_LIBRARIES += cocos_linearmath_static
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := cocos_bulletmultithreaded_static
LOCAL_MODULE_FILENAME := bulletmultithreaded
LOCAL_SRC_FILES := $(COCOS_ROOT)/external/bullet/prebuilt/android/$(TARGET_ARCH_ABI)/libBulletMultiThreaded.a
LOCAL_EXPORT_C_INCLUDES := $(COCOS_ROOT)/external/bullet/include
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := cocos_linearmath_static
LOCAL_MODULE_FILENAME := linearmath
LOCAL_SRC_FILES := $(COCOS_ROOT)/external/bullet/prebuilt/android/$(TARGET_ARCH_ABI)/libLinearMath.a
LOCAL_EXPORT_C_INCLUDES := $(COCOS_ROOT)/external/bullet/include
include $(PREBUILT_STATIC_LIBRARY)

include $(CLEAR_VARS)
LOCAL_MODULE := cocos_minicl_static
LOCAL_MODULE_FILENAME := minicl
LOCAL_SRC_FILES := $(COCOS_ROOT)/external/bullet/prebuilt/android/$(TARGET_ARCH_ABI)/libMiniCL.a
LOCAL_EXPORT_C_INCLUDES := $(COCOS_ROOT)/external/bullet/include
include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
include $(CLEAR_VARS)

LOCAL_MODULE    := box2d_static
LOCAL_MODULE_FILENAME := box2d_static
LOCAL_SRC_FILES := $(COCOS_ROOT)/external/Box2D/prebuilt/android/$(TARGET_ARCH_ABI)/libbox2d.a
LOCAL_EXPORT_C_INCLUDES := $(COCOS_ROOT)/external/Box2D/include
LOCAL_EXPORT_C_INCLUDES += $(COCOS_ROOT)/external/Box2D/include
include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
include $(CLEAR_VARS)
LOCAL_MODULE := cocos_zlib_static
LOCAL_MODULE_FILENAME := zlib
LOCAL_SRC_FILES := $(COCOS_ROOT)/external/zlib/prebuilt/android/$(TARGET_ARCH_ABI)/libz.a
LOCAL_EXPORT_C_INCLUDES := $(COCOS_ROOT)/external/zlib/include
include $(PREBUILT_STATIC_LIBRARY)


#zh 为通过 cocos gen-libs -p android 产生的静态库添加模块定义
#en Add module definitions for static libraries generated by 'cocos gen-libs -p android'
#=================================================================================
include $(CLEAR_VARS)
LOCAL_MODULE := cocos_flatbuffers_static
LOCAL_SRC_FILES := $(TARGET_ARCH_ABI)/flatbuffers.a
include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
include $(CLEAR_VARS)
LOCAL_MODULE := audioengine_static
LOCAL_SRC_FILES := $(TARGET_ARCH_ABI)/libaudioengine.a
include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
include $(CLEAR_VARS)
LOCAL_MODULE := cocos2dx_static
LOCAL_SRC_FILES := $(TARGET_ARCH_ABI)/libcocos2d.a
include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
include $(CLEAR_VARS)
LOCAL_MODULE := cocos2dxandroid_static
LOCAL_SRC_FILES := $(TARGET_ARCH_ABI)/libcocos2dandroid.a
include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
include $(CLEAR_VARS)
LOCAL_MODULE := cocos2dx_internal_static
LOCAL_SRC_FILES := $(TARGET_ARCH_ABI)/libcocos2dxinternal.a
include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
include $(CLEAR_VARS)
LOCAL_MODULE := cocos3d_static
LOCAL_SRC_FILES := $(TARGET_ARCH_ABI)/libcocos3d.a
include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
include $(CLEAR_VARS)
LOCAL_MODULE := cocosbuilder_static
LOCAL_SRC_FILES := $(TARGET_ARCH_ABI)/libcocosbuilder.a
include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
include $(CLEAR_VARS)
LOCAL_MODULE := cocosdenshion_static
LOCAL_SRC_FILES := $(TARGET_ARCH_ABI)/libcocosdenshion.a
include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
include $(CLEAR_VARS)
LOCAL_MODULE := cocostudio_static
LOCAL_SRC_FILES := $(TARGET_ARCH_ABI)/libcocostudio.a
include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
include $(CLEAR_VARS)
LOCAL_MODULE := cpufeatures
LOCAL_SRC_FILES := $(TARGET_ARCH_ABI)/libcpufeatures.a
include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
include $(CLEAR_VARS)
LOCAL_MODULE := cocos_extension_static
LOCAL_SRC_FILES := $(TARGET_ARCH_ABI)/libextension.a
include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
include $(CLEAR_VARS)
LOCAL_MODULE := cocos_network_static
LOCAL_SRC_FILES := $(TARGET_ARCH_ABI)/libnetwork.a
include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
include $(CLEAR_VARS)
LOCAL_MODULE := libpvmp3dec
LOCAL_SRC_FILES := $(TARGET_ARCH_ABI)/libpvmp3dec.a
include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
include $(CLEAR_VARS)
LOCAL_MODULE := recast_static
LOCAL_SRC_FILES := $(TARGET_ARCH_ABI)/librecast.a
include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
include $(CLEAR_VARS)
LOCAL_MODULE := spine_static
LOCAL_SRC_FILES := $(TARGET_ARCH_ABI)/libspine.a
include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
include $(CLEAR_VARS)
LOCAL_MODULE := cocos_ui_static
LOCAL_SRC_FILES := $(TARGET_ARCH_ABI)/libui.a
include $(PREBUILT_STATIC_LIBRARY)

#=================================================================================
include $(CLEAR_VARS)
LOCAL_MODULE := libvorbisidec
LOCAL_SRC_FILES := $(TARGET_ARCH_ABI)/libvorbisidec.a
include $(PREBUILT_STATIC_LIBRARY)