#import <Foundation/Foundation.h>
//#import <GoogleMobileAds/GoogleMobileAds.h>
// #include "HIVEAdKit.hpp"


static char* cStringCopy(NSString* input)
{
    const char* string = [input UTF8String];
    return string ? strdup(string) : NULL;
}
static NSString *NSStringFromCString(const char *bytes) { return bytes ? @(bytes) : nil; }

id getValueOrEmptyString(NSString* object) {
    if (!object) {
        return @"";
    }
    
    return object;
}

//#if TARGET_IPHONE_SIMULATOR
//extern const char* _getSimulatorDevice(void) {
//    return cStringCopy((NSString*)kGADSimulatorID);
//}
//#endif

@interface HIVEAnalyticsLogPlugin : NSObject

+ (void)sendLogWithData:(NSDictionary *)data;

@end

extern "C" {

    void HIVEAnlayticsLog_AdLog(const char* eventType, const char* adUnitId, const char* uniqueSessionKey, const char* network, const char* adPlacementInfo, const char* rewardType, double rewardAmount) {
        
        // Requirement common
        NSString* adEventType = NSStringFromCString(eventType);
        
        NSMutableDictionary *logData = [NSMutableDictionary dictionary];
        [logData setObject:@"hive_ad_watch_log" forKey:@"category"];
        
        [logData setObject:getValueOrEmptyString(adEventType) forKey:@"eventType"];
        [logData setObject:getValueOrEmptyString(NSStringFromCString(adUnitId)) forKey:@"adUnitId"];
        [logData setObject:getValueOrEmptyString(NSStringFromCString(uniqueSessionKey)) forKey:@"uniqueSessionKey"];
        [logData setObject:getValueOrEmptyString(NSStringFromCString(network)) forKey:@"adNetwork"];
        
        // load, open event
        // if( [adEventType isEqualToString:@"open"] || [adEventType isEqualToString:@"load"] ) {
            [logData setObject:getValueOrEmptyString(NSStringFromCString(adPlacementInfo)) forKey:@"adPlacement"];
        // }
        
        // reward event
        if( [adEventType isEqualToString:@"reward"] ) {
            [logData setObject:[NSNull null] forKey:@"rewardType"];
            [logData setObject:[NSNull null] forKey:@"rewardAmount"];
        }

        [logData setObject:@"ADOP" forKey:@"adSource"];//ADOP Fixed
        
        [HIVEAnalyticsLogPlugin sendLogWithData:logData];
    }

	const char* HIVEAnalyticsLog_CreateUniqueSessionKey() {
		return cStringCopy([[[NSUUID UUID] UUIDString] stringByReplacingOccurrencesOfString:@"-" withString:@""]);
	}
}
// MARK: - HIVEAnlayticsLogPlugin
@implementation HIVEAnalyticsLogPlugin

+ (void)sendLogWithData:(NSDictionary *)data {
    Class clasz = NSClassFromString(@"HIVEAnalyticsLogTransfer");
    SEL selector = NSSelectorFromString(@"getInstance");
    Class insClass = nil;
    if( clasz != nil && [clasz respondsToSelector:(NSSelectorFromString(@"getInstance"))] ) {
        // HIVE SDK v4(Objc) / HIVE SDK v1 / C2S module
        NSMethodSignature *methodSignature_getInstance = [clasz methodSignatureForSelector:selector];
        if (methodSignature_getInstance != nil) {
            
            NSInvocation *inv_getInstance = [NSInvocation invocationWithMethodSignature:methodSignature_getInstance];
            [inv_getInstance setSelector:selector];
            [inv_getInstance setTarget:clasz];
            [inv_getInstance invoke];
            [inv_getInstance getReturnValue:&insClass];
        }
    } else {
        insClass = clasz;
    }
    if (insClass != nil && [insClass respondsToSelector:(NSSelectorFromString(@"sendAnalyticsHiveLog:"))]) {
        SEL insSelector = NSSelectorFromString(@"sendAnalyticsHiveLog:");
        
        NSMethodSignature *methodSignature = [insClass methodSignatureForSelector:insSelector];
        if (methodSignature != nil) {
            NSInvocation *inv = [NSInvocation invocationWithMethodSignature:methodSignature];
            [inv setSelector:insSelector];
            [inv setTarget:insClass];
            [inv setArgument:&(data) atIndex:2];
            [inv invoke];
        }
    } else {
        // can not find class
        //			NSLog(@"Can't find class");
        // NSLog(@"LogData :  %@", data);
    }
}

@end
